import { globalApi } from '@/api'

// 获取菜单数据
const GET_MEUMS = 'GET_MEUMS'

// 显示设置快捷菜单
const SHOW_EDIT_MENUS = 'SHOW_EDIT_MENUS'

// 隐藏设置快捷菜单
const HIDE_EDIT_MENUS = 'HIDE_EDIT_MENUS'

// 边侧菜单
const SIDEBAR_UNFOLD = 'SIDEBAR_UNFOLD'

// 基本信息
const GET_PROJECT_INFO = 'GET_PROJECT_INFO'

const state = {
  menus: [],
  editMenus: false,
  projectInfo: null,
  currentMenus: [],
  sidebarUnfold: true // false:边侧菜单收缩, true:边侧菜单展开
}

const actions = {
  async getMenus({
    commit, dispatch
  }, parmas) {
    let res = await globalApi.getMenus(parmas)
    let menus = res.data.data
    commit(GET_MEUMS, menus)
  },
  showEditMenus({ commit }) {
    commit(SHOW_EDIT_MENUS, true)
  },
  computedSidebarUnfoldRouter({ commit, dispatch }, { route, menus }) {
    for (let index = 0; index < menus.length; index++) {
      const element = menus[index]
      if (element.link === route) {
        dispatch('setCurrentMenus', { index: `${index}`, item: element })
        break
      } else {
        for (let i = 0; i < element.length; i++) {
          const item = element[i]
          if (item.link === route) {
            dispatch('setCurrentMenus', { index: `${index}-${i}`, item })
            break
          } else {
            for (let j = 0; j < item.length; j++) {
              const it = item[j]
              if (it.link === route) {
                dispatch('setCurrentMenus', { index: `${index}-${i}-${j}`, item: it })
                break
              }
            }
          }
        }
      }
    }
  },
  hideEditMenus({ commit }) {
    commit(HIDE_EDIT_MENUS, false)
  },
  setSidebarUnfold({ commit }, type) {
    commit(SIDEBAR_UNFOLD, type)
  },

  async getProjectInfo({ commit, dispatch }) {
    let res = await globalApi.getProjectInfo()
    let projectInfo = res.data
    commit(GET_PROJECT_INFO, projectInfo)
  }
}

const getters = {
  getMenus(state) {
    return state.menus
  },
  getEditMenus(state) {
    return state.editMenus
  },
  getSidebarUnfoldInfo(state) {
    return state.sidebarUnfold
  },
  getProjectInfo(state) {
    return state.projectInfo
  },
  getCurrentMenus(state) {
    return state.currentMenus
  }
}

const mutations = {
  [GET_MEUMS](state, menus) {
    state.menus = [...menus]
  },

  [SHOW_EDIT_MENUS](state, status) {
    state.editMenus = status
  },
  [HIDE_EDIT_MENUS](state, status) {
    state.editMenus = status
  },
  [SIDEBAR_UNFOLD](state, type) {
    state.sidebarUnfold = type
  },
  [GET_PROJECT_INFO](state, projectInfo) {
    state.projectInfo = { ...projectInfo }
  }
}

export default {
  state,
  mutations,
  actions,
  getters
}
